Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePool.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePool.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePool.cs	(revision 4423)
@@ -1,13 +1,65 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
 using System.ServiceModel;
 using HeuristicLab.Common;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Contracts {
   public class WcfServicePool<T> {
     private static object locker = new object();
+
     private string hostAddress;
+    public string HostAddress {
+      get { return hostAddress; }
+      set {
+        if (hostAddress != value) {
+          hostAddress = value;
+          this.factory = null;
+        } 
+      }
+    }
+
+    private string endpointName;
+
     private string username;
+    public string Username {
+      get { return username; }
+      set { 
+        if(username != value) {
+          username = value;
+          this.factory = null;
+        }
+      }
+    }
+
     private string password;
-    private string endpointName;
+    public string Password {
+      set {
+        if (password != value) {
+          password = value;
+          this.factory = null;
+        }
+      }
+    }
+
     private ChannelFactory<T> factory = null;
     private Disposable<T> disposableService = null;
@@ -41,5 +93,5 @@
         factory.Credentials.UserName.Password = password;
       }
-
+      
       return factory.CreateChannel();
     }
@@ -48,10 +100,34 @@
       lock (locker) {
         requestCount++;
+        Logger.Debug("Request for ServiceProxy (count: " + requestCount + ")");
+        if (disposableService != null) {
+          if (GetServiceState() == CommunicationState.Faulted) {
+            DisposeService();
+          }
+        }
         if (disposableService == null) {
-          disposableService = new Disposable<T>(CreateFacade(endpointName));
-          disposableService.OnDisposing += new EventHandler(disposableService_OnDisposing);
-        }
+          disposableService = new Disposable<T>(CreateFacade(this.endpointName));
+          RegisterServiceEvents();
+        }        
         return disposableService;
       }
+    }
+
+    private void RegisterServiceEvents() {
+      disposableService.OnDisposing += new EventHandler(disposableService_OnDisposing);
+      ((ICommunicationObject)disposableService.Obj).Faulted += new EventHandler(WcfServicePool_Faulted);
+    }
+
+    private void DeregisterServiceEvents() {
+      disposableService.OnDisposing -= new EventHandler(disposableService_OnDisposing);
+      ((ICommunicationObject)disposableService.Obj).Faulted -= new EventHandler(WcfServicePool_Faulted);
+    }
+
+    private CommunicationState GetServiceState() {
+      return ((ICommunicationObject)disposableService.Obj).State;
+    }
+
+    void WcfServicePool_Faulted(object sender, EventArgs e) {
+      OnExceptionOccured(new CommunicationException(e.ToString()));
     }
 
@@ -63,7 +139,16 @@
       lock (locker) {
         requestCount--;
+        Logger.Debug("Disposing ServiceProxy (count: " + requestCount + ")");
         if (requestCount == 0) {
-          WcfSettings.DisposeWcfClient((ICommunicationObject)disposableService.Obj);
-          disposableService = null;
+          try {
+            DeregisterServiceEvents();
+            WcfSettings.DisposeWcfClient((ICommunicationObject)disposableService.Obj);
+          }
+          catch (Exception e) {
+            OnExceptionOccured(e);
+          }
+          finally {
+            disposableService = null;
+          }
         } else if (requestCount < 0) {
           throw new WcfServicePoolException("requestCount cannot be less than 0.");
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePoolException.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePoolException.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePoolException.cs	(revision 4423)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
 
 namespace HeuristicLab.Hive.Contracts {
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfSettings.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfSettings.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfSettings.cs	(revision 4423)
@@ -1,3 +1,23 @@
-﻿//#define USE_MSG_BINDING
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+//#define USE_MSG_BINDING
 using System;
 using System.Collections.Generic;
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HeuristicLab.Hive.Experiment.Views-3.3.csproj
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HeuristicLab.Hive.Experiment.Views-3.3.csproj	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HeuristicLab.Hive.Experiment.Views-3.3.csproj	(revision 4423)
@@ -142,22 +142,15 @@
     </Compile>
     <Compile Include="ControlExtensions.cs" />
-    <Compile Include="Form1.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Form1.Designer.cs">
-      <DependentUpon>Form1.cs</DependentUpon>
-    </Compile>
-    <Compile Include="TestApp.cs" />
-    <Compile Include="JobConfigListView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="JobConfigListView.Designer.cs">
-      <DependentUpon>JobConfigListView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="JobConfigView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="JobConfigView.Designer.cs">
-      <DependentUpon>JobConfigView.cs</DependentUpon>
+    <Compile Include="HiveJobListView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="HiveJobListView.Designer.cs">
+      <DependentUpon>HiveJobListView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="HiveJobView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="HiveJobView.Designer.cs">
+      <DependentUpon>HiveJobView.cs</DependentUpon>
     </Compile>
     <Compile Include="HiveExperimentListView.cs">
@@ -179,16 +172,4 @@
     <Compile Include="HiveExperimentView.Designer.cs">
       <DependentUpon>HiveExperimentView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="JobItemListView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="JobItemListView.Designer.cs">
-      <DependentUpon>JobItemListView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="JobItemView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="JobItemView.Designer.cs">
-      <DependentUpon>JobItemView.cs</DependentUpon>
     </Compile>
     <Compile Include="MenuItems\ConnectionSetupMenuItem.cs" />
@@ -232,9 +213,6 @@
       <DependentUpon>ConnectionSetupView.cs</DependentUpon>
     </EmbeddedResource>
-    <EmbeddedResource Include="Form1.resx">
-      <DependentUpon>Form1.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="JobConfigView.resx">
-      <DependentUpon>JobConfigView.cs</DependentUpon>
+    <EmbeddedResource Include="HiveJobView.resx">
+      <DependentUpon>HiveJobView.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="HiveClientView.resx">
@@ -243,7 +221,5 @@
     <EmbeddedResource Include="HiveExperimentView.resx">
       <DependentUpon>HiveExperimentView.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="JobItemView.resx">
-      <DependentUpon>JobItemView.cs</DependentUpon>
+      <SubType>Designer</SubType>
     </EmbeddedResource>
     <EmbeddedResource Include="ProgressView.resx">
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveClientView.Designer.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveClientView.Designer.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveClientView.Designer.cs	(revision 4423)
@@ -45,36 +45,10 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
-      this.experimentsTabPage = new System.Windows.Forms.TabPage();
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HiveClientView));
       this.hiveExperimentListView = new HeuristicLab.Hive.Experiment.Views.HiveExperimentListView();
-      this.logTabPage = new System.Windows.Forms.TabPage();
       this.updateExperimentsButton = new System.Windows.Forms.Button();
-      this.tabControl.SuspendLayout();
-      this.experimentsTabPage.SuspendLayout();
+      this.updateExperimentsPanel = new System.Windows.Forms.Panel();
+      this.updateExperimentsPanel.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // tabControl
-      // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.tabControl.Controls.Add(this.experimentsTabPage);
-      this.tabControl.Controls.Add(this.logTabPage);
-      this.tabControl.Location = new System.Drawing.Point(3, 3);
-      this.tabControl.Name = "tabControl";
-      this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(729, 489);
-      this.tabControl.TabIndex = 4;
-      // 
-      // experimentsTabPage
-      // 
-      this.experimentsTabPage.Controls.Add(this.hiveExperimentListView);
-      this.experimentsTabPage.Location = new System.Drawing.Point(4, 22);
-      this.experimentsTabPage.Name = "experimentsTabPage";
-      this.experimentsTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.experimentsTabPage.Size = new System.Drawing.Size(721, 463);
-      this.experimentsTabPage.TabIndex = 0;
-      this.experimentsTabPage.Text = "Experiments";
-      this.experimentsTabPage.UseVisualStyleBackColor = true;
       // 
       // hiveExperimentListView
@@ -85,26 +59,19 @@
       this.hiveExperimentListView.Caption = "HiveExperimentList View";
       this.hiveExperimentListView.Content = null;
-      this.hiveExperimentListView.Location = new System.Drawing.Point(6, 6);
+      this.hiveExperimentListView.Location = new System.Drawing.Point(3, 3);
       this.hiveExperimentListView.Name = "hiveExperimentListView";
       this.hiveExperimentListView.ReadOnly = false;
-      this.hiveExperimentListView.Size = new System.Drawing.Size(712, 437);
+      this.hiveExperimentListView.Size = new System.Drawing.Size(729, 518);
       this.hiveExperimentListView.TabIndex = 0;
-      // 
-      // logTabPage
-      // 
-      this.logTabPage.Location = new System.Drawing.Point(4, 22);
-      this.logTabPage.Name = "logTabPage";
-      this.logTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.logTabPage.Size = new System.Drawing.Size(721, 463);
-      this.logTabPage.TabIndex = 1;
-      this.logTabPage.Text = "Log";
-      this.logTabPage.UseVisualStyleBackColor = true;
       // 
       // updateExperimentsButton
       // 
-      this.updateExperimentsButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.updateExperimentsButton.Location = new System.Drawing.Point(3, 498);
+      this.updateExperimentsButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.updateExperimentsButton.Image = ((System.Drawing.Image)(resources.GetObject("updateExperimentsButton.Image")));
+      this.updateExperimentsButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      this.updateExperimentsButton.Location = new System.Drawing.Point(87, 28);
       this.updateExperimentsButton.Name = "updateExperimentsButton";
-      this.updateExperimentsButton.Size = new System.Drawing.Size(144, 23);
+      this.updateExperimentsButton.Size = new System.Drawing.Size(175, 59);
       this.updateExperimentsButton.TabIndex = 5;
       this.updateExperimentsButton.Text = "Update Experiment List";
@@ -112,14 +79,21 @@
       this.updateExperimentsButton.Click += new System.EventHandler(this.updateExperimentsButton_Click);
       // 
+      // updateExperimentsPanel
+      // 
+      this.updateExperimentsPanel.Controls.Add(this.updateExperimentsButton);
+      this.updateExperimentsPanel.Location = new System.Drawing.Point(228, 0);
+      this.updateExperimentsPanel.Name = "updateExperimentsPanel";
+      this.updateExperimentsPanel.Size = new System.Drawing.Size(360, 103);
+      this.updateExperimentsPanel.TabIndex = 6;
+      // 
       // HiveClientView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.tabControl);
-      this.Controls.Add(this.updateExperimentsButton);
+      this.Controls.Add(this.updateExperimentsPanel);
+      this.Controls.Add(this.hiveExperimentListView);
       this.Name = "HiveClientView";
       this.Size = new System.Drawing.Size(735, 524);
-      this.tabControl.ResumeLayout(false);
-      this.experimentsTabPage.ResumeLayout(false);
+      this.updateExperimentsPanel.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -127,9 +101,7 @@
     #endregion
 
-    private System.Windows.Forms.TabControl tabControl;
-    private System.Windows.Forms.TabPage experimentsTabPage;
-    private System.Windows.Forms.TabPage logTabPage;
     private System.Windows.Forms.Button updateExperimentsButton;
     private HiveExperimentListView hiveExperimentListView;
+    private System.Windows.Forms.Panel updateExperimentsPanel;
 
 
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveClientView.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveClientView.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveClientView.cs	(revision 4423)
@@ -30,4 +30,5 @@
 using HeuristicLab.Optimization.Views;
 using HeuristicLab.Hive.Experiment.Properties;
+using System.Threading;
 
 namespace HeuristicLab.Hive.Experiment.Views {
@@ -38,4 +39,6 @@
   [Content(typeof(HiveClient), true)]
   public sealed partial class HiveClientView : ItemView {
+    private ProgressView progressView;
+
     public new HiveClient Content {
       get { return (HiveClient)base.Content; }
@@ -48,18 +51,36 @@
     public HiveClientView() {
       InitializeComponent();
+      updateExperimentsPanel.Dock = DockStyle.Fill;
     }
 
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      if (Content == null) {
-        this.hiveExperimentListView.Content = null;
-      } else {
+      Content_HiveExperimentsChanged(this, EventArgs.Empty);
+      Content_IsProgressingChanged(this, EventArgs.Empty);
+    }
+
+    protected override void RegisterContentEvents() {
+      this.Content.HiveExperimentsChanged += new EventHandler(Content_HiveExperimentsChanged);
+      this.Content.IsProgressingChanged += new EventHandler(Content_IsProgressingChanged);
+    }
+
+    protected override void DeregisterContentEvents() {
+      this.Content.HiveExperimentsChanged -= new EventHandler(Content_HiveExperimentsChanged);
+      this.Content.IsProgressingChanged -= new EventHandler(Content_IsProgressingChanged);
+    }
+
+    private void Content_HiveExperimentsChanged(object sender, EventArgs e) {
+      if (Content != null) {
         this.hiveExperimentListView.Content = Content.HiveExperiments;
       }
     }
 
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      updateExperimentsPanel.Visible = Content != null && Content.HiveExperiments == null;
+
+    }
+
     private void updateExperimentsButton_Click(object sender, EventArgs e) {
-      ProgressView progressView = new ProgressView(this, "Loading Experiments from server...", true);
-
       MethodInvoker invoker = new MethodInvoker(Content.UpdateExperimentList);
       invoker.BeginInvoke((ar) => {
@@ -67,9 +88,37 @@
           invoker.EndInvoke(ar);
         }
-        finally {
-          progressView.Finish();
+        catch (Exception ex) {
+          ThreadPool.QueueUserWorkItem(delegate(object exception) { ErrorHandling.ShowErrorDialog(this, (Exception)exception); }, ex);
         }
       }, null);
     }
+
+    private void Content_IsProgressingChanged(object sender, EventArgs e) {
+      if (this.InvokeRequired) {
+        Invoke(new EventHandler(Content_IsProgressingChanged), sender, e);
+      } else {
+        if (Content != null && Content.IsProgressing) {
+          SetProgressView();
+        } else {
+          FinishProgressView();
+        }
+      }
+    }
+
+    private void SetProgressView() {
+      if (progressView == null) {
+        progressView = new ProgressView(this, Content.Progress);
+      } else {
+        progressView.Progress = Content.Progress;
+      }
+    }
+
+    private void FinishProgressView() {
+      if (progressView != null) {
+        progressView.Finish();
+        progressView = null;
+        SetEnabledStateOfControls();
+      }
+    }
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveExperimentListView.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveExperimentListView.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveExperimentListView.cs	(revision 4423)
@@ -29,5 +29,26 @@
 
     protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
+      if (InvokeRequired) {
+        this.InvokeIfRequired(c => { SetEnabledStateOfControls(); });
+      } else {
+        base.SetEnabledStateOfControls();
+        if (Content != null) {
+          if (itemsListView.SelectedItems.Count > 0) {
+            // only allow delete-operation if all selected items are stored in hive (they have HiveExperimentId)
+            bool canRemove = true;
+            foreach (ListViewItem item in itemsListView.SelectedItems) {
+              canRemove = canRemove && Content[item.Index].HiveExperimentId != Guid.Empty;
+            }
+            this.removeButton.Enabled = canRemove;
+          }
+        }
+      }
+    }
+
+    protected override void removeButton_Click(object sender, EventArgs e) {
+      DialogResult result = MessageBox.Show("This action will permanently delete this experiment (also on the hive server). Continue?", "Delete Experiment", MessageBoxButtons.OKCancel);
+      if (result == DialogResult.OK) {
+        base.removeButton_Click(sender, e);
+      }
     }
   }
